const plugin = require("tailwindcss/plugin");
const patterns = require("./patterns");

module.exports = plugin(function ({ addUtilities, theme }) {
  const colors = theme("colors", {});

  // flatten colors
  const flattenColors = {};
  Object.entries(colors).map(([name, color]) => {
    if (typeof color === "object") {
      Object.entries(color).map(([nestedName, nestedColor]) => {
        flattenColors[
          `${name}${nestedName === "default" ? "" : `-${nestedName}`}`
        ] = nestedColor;
      });
    } else {
      flattenColors[name] = color;
    }
  });

  let newUtilities = {};
  Object.entries(patterns).map(([name, pattern]) =>
    Object.entries(flattenColors).map(
      ([colorName, color]) =>
        (newUtilities[`.svg-${name}-${colorName}`] = {
          backgroundImage: pattern
            .replace("{{color}}", color.replace("#", "%23"))
            .replace("{{opacity}}", 1), // TODO: maybe map all opacity here
        })
    )
  );

  addUtilities(newUtilities);
});
